*** ./chan_sip.c.original	2009-10-12 19:55:16.000000000 -0300
--- ./chan_sip.c	2009-10-12 20:04:08.385384039 -0300
***************
*** 9955,9961 ****
  {
  	struct sip_user *user = NULL;
  	struct sip_peer *peer;
! 	char from[256], *c;
  	char *of;
  	char rpid_num[50];
  	const char *rpid;
--- 9955,9961 ----
  {
  	struct sip_user *user = NULL;
  	struct sip_peer *peer;
! 	char from[256], to[256], *c;
  	char *of;
  	char rpid_num[50];
  	const char *rpid;
***************
*** 10133,10139 ****
  			/* If peer is registered from this IP address or have this as a default
  			   IP address, this call is from the peer 
  			*/
! 			peer = find_peer(NULL, &p->recv, 1, 0);
  
  		if (peer) {
  			/* Set Frame packetization */
--- 10133,10157 ----
  			/* If peer is registered from this IP address or have this as a default
  			   IP address, this call is from the peer 
  			*/
! 			ast_copy_string(to, get_header(req, "To"), sizeof(from));
! 			of = get_in_brackets(to);
! 			if (strncasecmp(of, "sip:", 4)) {
! 			    ast_log(LOG_NOTICE, "To address missing 'sip:', using it anyway\n");
! 			} else
! 			    of += 4;
! 
! 			/* Get just the username part */
! 			if ((c = strchr(of, '@')))
! 				*c = '\0';
! 
! 			/* Try to find peer based on IP address and To: header user */
! 			peer = find_peer(of, &p->recv, 1, 0);
! 
! 			/* Fall back to previous bahavior, find any peer on this address */
! 			if (!peer)
! 			    peer = find_peer(NULL, &p->recv, 1, 0);
! 			if (peer && debug)
! 			    ast_verbose("Found peer '%s'\n", peer->name);
  
  		if (peer) {
  			/* Set Frame packetization */
